import type { ParsedUrlQuery } from 'querystring';
import type { z } from 'zod';
export interface SetRouterQueryParamsOptions {
    shallow?: boolean;
    locale?: string;
    scroll?: boolean;
    replace?: boolean;
    logErrorsToConsole?: boolean;
    keepEmptyParameters?: boolean;
}
export type SetQueryParamOptions = SetRouterQueryParamsOptions & {
    pathname?: string;
};
type SetQueryParamsFn<T> = (newParams: Partial<T>, options?: SetQueryParamOptions) => Promise<boolean>;
export declare const createQueryParamStore: <P extends z.ZodType>(schema: P, routerOptions?: SetRouterQueryParamsOptions) => {
    useQueryParam: <K extends keyof z.infer<P>>(key: K, initialQuery?: ParsedUrlQuery) => [z.infer<P>[K], (newValue: z.infer<P>[K], options?: SetQueryParamOptions) => Promise<boolean>];
    useQueryParams: (initialQuery?: ParsedUrlQuery) => [z.infer<P>, SetQueryParamsFn<z.infer<P>>];
};
export {};
